// python wrapper for vtkPostgreSQLQuery
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkStdString.h"
#include "vtkPostgreSQLQuery.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPostgreSQLQuery(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPostgreSQLQuery_ClassNew(); }

#ifndef DECLARED_PyvtkSQLQuery_ClassNew
extern "C" { PyObject *PyvtkSQLQuery_ClassNew(); }
#define DECLARED_PyvtkSQLQuery_ClassNew
#endif

static const char **PyvtkPostgreSQLQuery_Doc();


static PyObject *
PyvtkPostgreSQLQuery_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPostgreSQLQuery *op = static_cast<vtkPostgreSQLQuery *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPostgreSQLQuery::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPostgreSQLQuery_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPostgreSQLQuery *op = static_cast<vtkPostgreSQLQuery *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPostgreSQLQuery::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPostgreSQLQuery_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPostgreSQLQuery *op = static_cast<vtkPostgreSQLQuery *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPostgreSQLQuery *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPostgreSQLQuery::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPostgreSQLQuery_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkPostgreSQLQuery *tempr = vtkPostgreSQLQuery::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPostgreSQLQuery_Execute(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Execute");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPostgreSQLQuery *op = static_cast<vtkPostgreSQLQuery *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->Execute() :
      op->vtkPostgreSQLQuery::Execute());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPostgreSQLQuery_GetNumberOfFields(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfFields");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPostgreSQLQuery *op = static_cast<vtkPostgreSQLQuery *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfFields() :
      op->vtkPostgreSQLQuery::GetNumberOfFields());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPostgreSQLQuery_GetFieldName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFieldName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPostgreSQLQuery *op = static_cast<vtkPostgreSQLQuery *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetFieldName(temp0) :
      op->vtkPostgreSQLQuery::GetFieldName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPostgreSQLQuery_GetFieldType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFieldType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPostgreSQLQuery *op = static_cast<vtkPostgreSQLQuery *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetFieldType(temp0) :
      op->vtkPostgreSQLQuery::GetFieldType(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPostgreSQLQuery_NextRow(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NextRow");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPostgreSQLQuery *op = static_cast<vtkPostgreSQLQuery *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->NextRow() :
      op->vtkPostgreSQLQuery::NextRow());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPostgreSQLQuery_HasError(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasError");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPostgreSQLQuery *op = static_cast<vtkPostgreSQLQuery *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasError() :
      op->vtkPostgreSQLQuery::HasError());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPostgreSQLQuery_BeginTransaction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "BeginTransaction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPostgreSQLQuery *op = static_cast<vtkPostgreSQLQuery *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->BeginTransaction() :
      op->vtkPostgreSQLQuery::BeginTransaction());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPostgreSQLQuery_RollbackTransaction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RollbackTransaction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPostgreSQLQuery *op = static_cast<vtkPostgreSQLQuery *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->RollbackTransaction() :
      op->vtkPostgreSQLQuery::RollbackTransaction());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPostgreSQLQuery_CommitTransaction(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CommitTransaction");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPostgreSQLQuery *op = static_cast<vtkPostgreSQLQuery *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->CommitTransaction() :
      op->vtkPostgreSQLQuery::CommitTransaction());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPostgreSQLQuery_DataValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DataValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPostgreSQLQuery *op = static_cast<vtkPostgreSQLQuery *>(vp);

  vtkIdType temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkVariant tempr = (ap.IsBound() ?
      op->DataValue(temp0) :
      op->vtkPostgreSQLQuery::DataValue(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkVariant");
    }
  }

  return result;
}


static PyObject *
PyvtkPostgreSQLQuery_GetLastErrorText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLastErrorText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPostgreSQLQuery *op = static_cast<vtkPostgreSQLQuery *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetLastErrorText() :
      op->vtkPostgreSQLQuery::GetLastErrorText());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPostgreSQLQuery_EscapeString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "EscapeString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPostgreSQLQuery *op = static_cast<vtkPostgreSQLQuery *>(vp);

  vtkStdString temp0;
  bool temp1 = true;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetValue(temp0) &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    vtkStdString tempr = (ap.IsBound() ?
      op->EscapeString(temp0, temp1) :
      op->vtkPostgreSQLQuery::EscapeString(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPostgreSQLQuery_GetNumberOfRows(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfRows");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPostgreSQLQuery *op = static_cast<vtkPostgreSQLQuery *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfRows() :
      op->vtkPostgreSQLQuery::GetNumberOfRows());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPostgreSQLQuery_Methods[] = {
  {"GetClassName", PyvtkPostgreSQLQuery_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkPostgreSQLQuery_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkPostgreSQLQuery_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPostgreSQLQuery\nC++: vtkPostgreSQLQuery *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkPostgreSQLQuery_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkPostgreSQLQuery\nC++: vtkPostgreSQLQuery *SafeDownCast(vtkObject* o)\n\n"},
  {"Execute", PyvtkPostgreSQLQuery_Execute, METH_VARARGS,
   "V.Execute() -> bool\nC++: bool Execute()\n\nExecute the query.  This must be performed before any field name\nor data access functions are used.\n"},
  {"GetNumberOfFields", PyvtkPostgreSQLQuery_GetNumberOfFields, METH_VARARGS,
   "V.GetNumberOfFields() -> int\nC++: int GetNumberOfFields()\n\nThe number of fields in the query result.\n"},
  {"GetFieldName", PyvtkPostgreSQLQuery_GetFieldName, METH_VARARGS,
   "V.GetFieldName(int) -> string\nC++: const char *GetFieldName(int i)\n\nReturn the name of the specified query field.\n"},
  {"GetFieldType", PyvtkPostgreSQLQuery_GetFieldType, METH_VARARGS,
   "V.GetFieldType(int) -> int\nC++: int GetFieldType(int i)\n\nReturn the type of the field, using the constants defined in\nvtkType.h.\n"},
  {"NextRow", PyvtkPostgreSQLQuery_NextRow, METH_VARARGS,
   "V.NextRow() -> bool\nC++: bool NextRow()\n\nAdvance row, return false if past end.\n"},
  {"HasError", PyvtkPostgreSQLQuery_HasError, METH_VARARGS,
   "V.HasError() -> bool\nC++: bool HasError()\n\nReturn true if there is an error on the current query.\n"},
  {"BeginTransaction", PyvtkPostgreSQLQuery_BeginTransaction, METH_VARARGS,
   "V.BeginTransaction() -> bool\nC++: bool BeginTransaction()\n\nBegin, abort (roll back), or commit a transaction.\n"},
  {"RollbackTransaction", PyvtkPostgreSQLQuery_RollbackTransaction, METH_VARARGS,
   "V.RollbackTransaction() -> bool\nC++: bool RollbackTransaction()\n\nBegin, abort (roll back), or commit a transaction.\n"},
  {"CommitTransaction", PyvtkPostgreSQLQuery_CommitTransaction, METH_VARARGS,
   "V.CommitTransaction() -> bool\nC++: bool CommitTransaction()\n\nBegin, abort (roll back), or commit a transaction.\n"},
  {"DataValue", PyvtkPostgreSQLQuery_DataValue, METH_VARARGS,
   "V.DataValue(int) -> vtkVariant\nC++: vtkVariant DataValue(vtkIdType c)\n\nReturn data in current row, field c\n"},
  {"GetLastErrorText", PyvtkPostgreSQLQuery_GetLastErrorText, METH_VARARGS,
   "V.GetLastErrorText() -> string\nC++: const char *GetLastErrorText()\n\nGet the last error text from the query\n"},
  {"EscapeString", PyvtkPostgreSQLQuery_EscapeString, METH_VARARGS,
   "V.EscapeString(string, bool) -> string\nC++: virtual vtkStdString EscapeString(vtkStdString s,\n    bool addSurroundingQuotes=true)\n\nEscape a string for inclusion into an SQL query\n"},
  {"GetNumberOfRows", PyvtkPostgreSQLQuery_GetNumberOfRows, METH_VARARGS,
   "V.GetNumberOfRows() -> int\nC++: int GetNumberOfRows()\n\nUnlike some databases, Postgres can tell you right away how many\nrows are in the results of your query.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPostgreSQLQuery_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOPostgreSQLPython.vtkPostgreSQLQuery", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPostgreSQLQuery_StaticNew()
{
  return vtkPostgreSQLQuery::New();
}

PyObject *PyvtkPostgreSQLQuery_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPostgreSQLQuery_Type, PyvtkPostgreSQLQuery_Methods,
    "vtkPostgreSQLQuery",
    PyvtkPostgreSQLQuery_Doc(), &PyvtkPostgreSQLQuery_StaticNew);

  PyTypeObject *pytype = &PyvtkPostgreSQLQuery_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkSQLQuery_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPostgreSQLQuery_Doc()
{
  static const char *docstring[] = {
    "vtkPostgreSQLQuery - vtkSQLQuery implementation for PostgreSQL\ndatabases\n\n",
    "Superclass: vtkSQLQuery\n\n",
    "This is an implementation of vtkSQLQuery for PostgreSQL databases. \nSee the documentation for vtkSQLQuery for information about what the\nmethods do.\n\n@par Thanks: Thanks to David Thompson and Andy Wilson from Sandia\nNational Laboratories for implementing this class.\n\n@sa\nvtkSQLDatabase vtkSQLQuery vtkPostgreSQLDatabase\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPostgreSQLQuery(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPostgreSQLQuery_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPostgreSQLQuery", o) != 0)
  {
    Py_DECREF(o);
  }

}

